package de.berlin.airport.artemis;

import java.io.IOException;

import javax.management.InstanceNotFoundException;
import javax.management.MBeanException;
import javax.management.MBeanServerConnection;
import javax.management.MalformedObjectNameException;
import javax.management.ObjectName;
import javax.management.ReflectionException;

public class JMXQueue {
    private MBeanServerConnection beanConnector;
    private ObjectName queueBean;

    public JMXQueue(String brokerBeanName, String queueName, MBeanServerConnection beanConnector) throws MalformedObjectNameException {
        this.beanConnector = beanConnector;
        this.queueBean = new ObjectName(String.format("%s,component=addresses,address=\"%s\"", brokerBeanName, queueName));
    }

    public void pause() throws MalformedObjectNameException, InstanceNotFoundException, MBeanException, ReflectionException, IOException {
        beanConnector.invoke(queueBean, "pause", null, null);
    }

    public void resume() throws MalformedObjectNameException, InstanceNotFoundException, MBeanException, ReflectionException, IOException {
        beanConnector.invoke(queueBean, "resume", null, null);
    }

}
